#coding=utf-8
#import this for eBay and Amazon use
import urllib
import urllib2

class BaseInterface(object):
    """
    Use EIC webservice
    """
    _method_call = {
        'eBay':{
            "getSessionId": 'getSessionId',
            "getTokenUrl": 'getTokenUrl',
            "getToken": 'getToken',
            "getImgUrl" : "getImgUrl",
            "getOrder": 'getOrder',
            "listOrders": 'listOrders',
            "uploadTrack": 'uploadTrack',
        },
        'Amazon':{
            "getToken": 'getToken',
            "getImgUrl": 'getImgUrl',
            "getOrder": 'getOrder',
            "listOrders": 'listOrders',
            "listOrdersMore": 'listOrdersMore',
            "listOrderItems": 'listOrderItems',
            "listOrderItemsMore": 'listOrderItemsMore',
            "uploadTrack": 'uploadTrack',
            "ListFinancialEventGroups":'ListFinancialEventGroups',
            "listFinaceEvent":'listFinaceEvent',
        },
        'Aliexpress':{
            "getOrder": 'getOrder',
            "listOrders": 'listOrders',
        }
    }

    _url='http://54.210.2.135:8234/marketplaces/webservice'
    _data = {}
    _timeout = 300

    def _make_call(self):
        """
        :return: 这里主要做urlopen，另外是要处理请求的异常处理
        """
        try:
            return urllib2.urlopen(self._url,urllib.urlencode(self._data), timeout=self._timeout).read()
        except urllib2.HTTPError as http_error:
            print 'HTTP error:', str(http_error)
            raise(http_error)
        except urllib2.URLError as url_error:
            print 'URL error:', str(url_error)
            if (type(url_error.reason) == urllib2.socket.timeout):
                print 'URL error: request again'
                return urllib2.urlopen(self._url,urllib.urlencode(self._data), timeout=2 * self._timeout).read()
        except Exception as e:
            print 'Unkown error:', str(e)
            if str(e).find('timed out') != '-1':
                print 'Unkown error: request again'
                return urllib2.urlopen(self._url,urllib.urlencode(self._data), timeout=2 * self._timeout).read()
            else:
                raise(e)

    def getImgUrl(self,**args):
        '''
        @param **args: 
            {'itemID':itemID}
            {'type':type,'id':[id]}
        '''
        pass
    
    def uploadTrack(self,submit_list):
        pass
    
    def listOrders(self,**args):
        '''
        @param **args: 
            {'timeFrom':timeFrom,'timeTo':timeTo,'Pagenumber':Pagenumber,'PerPage':PerPage,'OrderRole':OrderRole,'OrderStatus':OrderStatus,'DetailLevel':DetailLevel}
            {'created_after':created_after,'created_before':created_before,'lastupdatedafter':lastupdatedafter,'lastupdatedbefore':lastupdatedbefore,'orderstatus':orderstatus,'fulfillment_channels':fulfillment_channels,'payment_methods':payment_methods,'buyer_email':buyer_email,'seller_orderid':seller_orderid,'PerPage':PerPage
            }
        '''
        pass
    
    def getOrder(self,**args):
        '''
        @param **args: 
            {'OrderIDS':OrderIDS}
            {'amazon_order_ids':amazon_order_ids}
        '''
        pass
    
    def getToken(self,**args):
        '''
        @param **args: 
            {'SessionID':SessionID}
            {'MWSAuthToken':MWSAuthToken}
        '''
        pass
    
    def getTokenUrl(self,**args):
        '''
        @param **args: 
            {'SessionID':SessionID}
        '''
        pass
    
    def getSessionId(self,args):
        pass
    
    def listOrdersMore(self,**args):
        '''
        @param **args: 
            {'token':token}
        '''
        pass
    
    def listOrderItems(self,**args):
        '''
        @param **args:
            {'amazon_order_id':amazon_order_id} 
        '''
        pass
    
    def listOrderItemsMore(self,**args):
        pass

    def listFinaceEventGroup(self,**args):
        pass

    def listFinaceEvent(self,**args):
        pass
    pass
